package org.openxma.dsl.generator;

import static com.google.inject.name.Names.named;

import org.eclipse.xtext.generator.IGenerator;
import org.openxma.dsl.generator.impl.DataTypeGenerator;
import org.openxma.dsl.generator.impl.DataViewGenerator;
import org.openxma.dsl.generator.impl.EntityGenerator;
import org.openxma.dsl.generator.impl.HbmXmlFileGenerator;
import org.openxma.dsl.generator.impl.JsfGenerator;
import org.openxma.dsl.generator.impl.Jsr303FeatureExtension;
import org.openxma.dsl.generator.impl.PomGenerator;
import org.openxma.dsl.generator.impl.RepositoryGenerator;
import org.openxma.dsl.generator.impl.ServiceGenerator;
import org.openxma.dsl.generator.impl.SessionContextGenerator;
import org.openxma.dsl.generator.impl.ValidatorGenerator;
import org.openxma.dsl.generator.impl.ValueObjectGenerator;
import org.openxma.dsl.generator.impl.XtendDomGenerator;

import com.google.inject.Binder;
import com.google.inject.Module;

public class DefaultGeneratorModule implements Module {

    public void configure(Binder binder) {
        binder.bind(Generator.class).annotatedWith(named("dmlGenerator")).to(XtendDomGenerator.class);
        binder.bind(Generator.class).annotatedWith(named("pmlGenerator")).to(PomGenerator.class);
        binder.bind(Generator.class).annotatedWith(named("jsf.pmlGenerator")).to(JsfGenerator.class);
        binder.bind(IGenerator.class).annotatedWith(named("valueObjectGenerator")).to(ValueObjectGenerator.class);
        binder.bind(IGenerator.class).annotatedWith(named("repositoryGenerator")).to(RepositoryGenerator.class);
        binder.bind(IGenerator.class).annotatedWith(named("hbmXmlFileGenerator")).to(HbmXmlFileGenerator.class);
        binder.bind(IGenerator.class).annotatedWith(named("entityGenerator")).to(EntityGenerator.class);
        binder.bind(IGenerator.class).annotatedWith(named("dataTypeGenerator")).to(DataTypeGenerator.class);
        binder.bind(IGenerator.class).annotatedWith(named("serviceGenerator")).to(ServiceGenerator.class);
        binder.bind(IGenerator.class).annotatedWith(named("dataViewGenerator")).to(DataViewGenerator.class);
        binder.bind(IGenerator.class).annotatedWith(named("validatorGenerator")).to(ValidatorGenerator.class);
        binder.bind(IGenerator.class).annotatedWith(named("sessionContextGenerator")).to(SessionContextGenerator.class);
        binder.bind(FeatureExtensions.class).to(Jsr303FeatureExtension.class);
    }

}
