package org.openxma.dsl.generator.component;

import java.io.File;

import org.eclipse.xpand2.output.FileHandle;
import org.eclipse.xpand2.output.Outlet;

public class DelegatingFileHandle implements FileHandle {
	private FileHandle fileHandle;

	public DelegatingFileHandle(FileHandle fileHandle) {
		this.fileHandle = fileHandle;
	}

	public String getAbsolutePath() {
		return fileHandle.getAbsolutePath();
	}

	public CharSequence getBuffer() {
		return fileHandle.getBuffer();
	}

	public String getFileEncoding() {
		return fileHandle.getFileEncoding();
	}

	public Outlet getOutlet() {
		return fileHandle.getOutlet();
	}

	public File getTargetFile() {
		return fileHandle.getTargetFile();
	}

	public boolean isAppend() {
		return fileHandle.isAppend();
	}

	public boolean isOverwrite() {
		return fileHandle.isOverwrite();
	}

	public void setBuffer(CharSequence buffer) {
		fileHandle.setBuffer(buffer);
	}

	public void writeAndClose() {
		fileHandle.writeAndClose();
		getOutlet().afterClose(this);
	}

}
