package org.openxma.dsl.generator.impl;

import static org.openxma.dsl.generator.helper.NameExtension.getFullyQualifiedName;
import static org.openxma.dsl.generator.helper.NameExtension.getName;

import org.eclipse.emf.ecore.util.EcoreUtil;
import org.openxma.dsl.common.Strings;
import org.openxma.dsl.core.model.Model;
import org.openxma.dsl.dom.model.Dependant;
import org.openxma.dsl.generator.Config;
import org.openxma.dsl.pom.PomPackage;
import org.openxma.dsl.pom.model.Component;

import at.spardat.xma.guidesign.XMAComponent;

public class DomComponentLogicAttachementStrategy extends AbstractPomDslAttachmentStrategySupport {

	@Override
	public String genAdditionalImportsServer(XMAComponent xmaComponent) {
		Model model = getReferencingPomModel(xmaComponent);
		if (model != null) {
			StringBuilder stringBuilder = new StringBuilder();
			Component component = (Component) EcoreUtil.getObjectByType(model.getElements(), PomPackage.eINSTANCE
					.getComponent());
			for (Dependant dependant : component.getDependencies()) {
				stringBuilder.append("import ").append(getFullyQualifiedName(dependant, false)).append(";").append(Config.NL);
			}
			return stringBuilder.toString();
		}
		return super.genAdditionalImportsServer(xmaComponent);
	}

	@Override
	public String genAdditionalMemberVariablesServer(XMAComponent xmaComponent) {
		StringBuilder stringBuilder = new StringBuilder();
		Model model = getReferencingPomModel(xmaComponent);
		if (model != null) {
			Component component = (Component) EcoreUtil.getObjectByType(model.getElements(), PomPackage.eINSTANCE
					.getComponent());
			for (Dependant dependant : component.getDependencies()) {
				stringBuilder.append("    @org.springframework.beans.factory.annotation.Autowired").append(Config.NL).append("    ").append(getFullyQualifiedName(dependant, false)).append(
						" ").append(Strings.uncapitalize(getName(dependant, false))).append(";").append(Config.NL);

			}
		}
		return stringBuilder.toString();
	}

}
