package org.openxma.dsl.generator.impl;

import com.google.common.base.Objects;
import java.util.Arrays;
import javax.inject.Inject;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.xtend2.lib.StringConcatenation;
import org.eclipse.xtext.xbase.lib.IterableExtensions;
import org.eclipse.xtext.xbase.lib.Procedures.Procedure1;
import org.eclipse.xtext.xbase.lib.StringExtensions;
import org.openxma.dsl.common.extensions.EObjectPropertiesAdapter;
import org.openxma.dsl.core.model.AdditiveExpr;
import org.openxma.dsl.core.model.AdditiveOp;
import org.openxma.dsl.core.model.AdditiveRights;
import org.openxma.dsl.core.model.AtomicBoolExpr;
import org.openxma.dsl.core.model.AtomicExpr;
import org.openxma.dsl.core.model.Call;
import org.openxma.dsl.core.model.CondANDExpr;
import org.openxma.dsl.core.model.CondANDRights;
import org.openxma.dsl.core.model.CondORExpr;
import org.openxma.dsl.core.model.CondORRights;
import org.openxma.dsl.core.model.DataTypeAndTypeParameter;
import org.openxma.dsl.core.model.EqualityExpr;
import org.openxma.dsl.core.model.EqualityOp;
import org.openxma.dsl.core.model.FalseLiteral;
import org.openxma.dsl.core.model.Function;
import org.openxma.dsl.core.model.IntLiteral;
import org.openxma.dsl.core.model.Literal;
import org.openxma.dsl.core.model.MultiplicativeExpr;
import org.openxma.dsl.core.model.MultiplicativeOp;
import org.openxma.dsl.core.model.MultiplicativeRights;
import org.openxma.dsl.core.model.ParenExpr;
import org.openxma.dsl.core.model.ReferenceableByXmadslVariable;
import org.openxma.dsl.core.model.RelationalExpr;
import org.openxma.dsl.core.model.RelationalOp;
import org.openxma.dsl.core.model.SimpleType;
import org.openxma.dsl.core.model.StatusFlag;
import org.openxma.dsl.core.model.StringLiteral;
import org.openxma.dsl.core.model.TrueLiteral;
import org.openxma.dsl.core.model.Type;
import org.openxma.dsl.core.model.Variable;
import org.openxma.dsl.core.model.VariableAccess;
import org.openxma.dsl.core.model.XmadslVariable;
import org.openxma.dsl.dom.model.ApplicationSession;
import org.openxma.dsl.dom.model.Attribute;
import org.openxma.dsl.dom.model.Property;
import org.openxma.dsl.generator.helper.ExpressionExtension;
import org.openxma.dsl.generator.helper.SimpleTypeExtension;
import org.openxma.dsl.generator.impl.Features;
import org.openxma.dsl.generator.impl.Names;

@SuppressWarnings("all")
public class ExpressionCompiler {
  @Inject
  private Features _features;
  
  @Inject
  private Names _names;
  
  protected String _compile(final EObject it) {
    return null;
  }
  
  protected String _compile(final EqualityExpr it) {
    String _xblockexpression = null;
    {
      CondORExpr _left = it.getLeft();
      String result = this.compile(_left);
      EqualityOp _op = it.getOp();
      String _string = _op.toString();
      ExpressionExtension.pushOperator(it, _string);
      CondORExpr _right = it.getRight();
      boolean _notEquals = (!Objects.equal(_right, null));
      if (_notEquals) {
        CondORExpr _right_1 = it.getRight();
        String _compile = this.compile(_right_1);
        String _plus = (result + _compile);
        result = _plus;
      }
      _xblockexpression = (result);
    }
    return _xblockexpression;
  }
  
  protected String _compile(final CondORExpr it) {
    CondANDExpr _left = it.getLeft();
    EList<CondORRights> _rights = it.getRights();
    String _compileLeftThenRight = this.compileLeftThenRight(_left, _rights);
    return _compileLeftThenRight;
  }
  
  protected String _compile(final CondANDExpr it) {
    AtomicBoolExpr _left = it.getLeft();
    EList<CondANDRights> _rights = it.getRights();
    String _compileLeftThenRight = this.compileLeftThenRight(_left, _rights);
    return _compileLeftThenRight;
  }
  
  protected String _compile(final CondORRights it) {
    String _xblockexpression = null;
    {
      ExpressionExtension.pushOperator(it, "||");
      CondANDExpr _right = it.getRight();
      String _compile = this.compile(_right);
      _xblockexpression = (_compile);
    }
    return _xblockexpression;
  }
  
  protected String _compile(final CondANDRights it) {
    String _xblockexpression = null;
    {
      ExpressionExtension.pushOperator(it, "&&");
      AtomicBoolExpr _right = it.getRight();
      String _compile = this.compile(_right);
      _xblockexpression = (_compile);
    }
    return _xblockexpression;
  }
  
  protected String _compile(final RelationalExpr it) {
    String _xblockexpression = null;
    {
      AdditiveExpr _left = it.getLeft();
      String result = this.compile(_left);
      RelationalOp _op = it.getOp();
      String _string = _op.toString();
      ExpressionExtension.pushOperator(it, _string);
      AdditiveExpr _right = it.getRight();
      boolean _notEquals = (!Objects.equal(_right, null));
      if (_notEquals) {
        AdditiveExpr _right_1 = it.getRight();
        String _compile = this.compile(_right_1);
        String _plus = (result + _compile);
        result = _plus;
      }
      _xblockexpression = (result);
    }
    return _xblockexpression;
  }
  
  protected String _compile(final AdditiveExpr it) {
    MultiplicativeExpr _left = it.getLeft();
    EList<AdditiveRights> _rights = it.getRights();
    String _compileLeftThenRight = this.compileLeftThenRight(_left, _rights);
    return _compileLeftThenRight;
  }
  
  protected String _compile(final AdditiveRights it) {
    String _xblockexpression = null;
    {
      AdditiveOp _op = it.getOp();
      String _string = _op.toString();
      ExpressionExtension.pushOperator(it, _string);
      MultiplicativeExpr _right = it.getRight();
      String _compile = this.compile(_right);
      _xblockexpression = (_compile);
    }
    return _xblockexpression;
  }
  
  protected String _compile(final MultiplicativeExpr it) {
    AtomicExpr _left = it.getLeft();
    EList<MultiplicativeRights> _rights = it.getRights();
    String _compileLeftThenRight = this.compileLeftThenRight(_left, _rights);
    return _compileLeftThenRight;
  }
  
  protected String _compile(final MultiplicativeRights it) {
    String _xblockexpression = null;
    {
      MultiplicativeOp _op = it.getOp();
      String _string = _op.toString();
      ExpressionExtension.pushOperator(it, _string);
      AtomicExpr _right = it.getRight();
      String _compile = this.compile(_right);
      _xblockexpression = (_compile);
    }
    return _xblockexpression;
  }
  
  protected String _compile(final XmadslVariable it) {
    String _switchResult = null;
    VariableAccess _access = it.getAccess();
    final VariableAccess getAccess = _access;
    boolean _matched = false;
    if (!_matched) {
      if (Objects.equal(getAccess,VariableAccess.NULL)) {
        _matched=true;
        ReferenceableByXmadslVariable _reference = it.getReference();
        String _compile = this.compile(_reference, it);
        _switchResult = _compile;
      }
    }
    if (!_matched) {
      if (Objects.equal(getAccess,VariableAccess.VALUE)) {
        _matched=true;
        ReferenceableByXmadslVariable _reference_1 = it.getReference();
        String _compile_1 = this.compile(_reference_1, it);
        _switchResult = _compile_1;
      }
    }
    if (!_matched) {
      if (Objects.equal(getAccess,VariableAccess.HAS_VALUE)) {
        _matched=true;
        String _beginAtomicExpr = this.beginAtomicExpr(it, it);
        String _plus = (_beginAtomicExpr + "(");
        ReferenceableByXmadslVariable _reference_2 = it.getReference();
        String _compile_2 = this.compile(_reference_2, it);
        String _plus_1 = (_plus + _compile_2);
        String _plus_2 = (_plus_1 + "!=null)");
        _switchResult = _plus_2;
      }
    }
    if (!_matched) {
      if (Objects.equal(getAccess,VariableAccess.IS_VALID)) {
        _matched=true;
        _switchResult = "ToDo";
      }
    }
    return _switchResult;
  }
  
  protected String _compile(final Property it, final Variable variable) {
    StringConcatenation _builder = new StringConcatenation();
    String _beginAtomicExpr = this.beginAtomicExpr(it, variable);
    _builder.append(_beginAtomicExpr, "");
    _builder.append("getContext().");
    String _accessorMethodName = this._features.getAccessorMethodName(it);
    _builder.append(_accessorMethodName, "");
    _builder.append("()");
    String _endAtomicExpr = this.endAtomicExpr(it, variable);
    _builder.append(_endAtomicExpr, "");
    return _builder.toString();
  }
  
  protected String _compile(final StatusFlag it, final Variable variable) {
    StringConcatenation _builder = new StringConcatenation();
    String _beginAtomicExpr = this.beginAtomicExpr(it, variable);
    _builder.append(_beginAtomicExpr, "");
    {
      EObject _eContainer = it.eContainer();
      EObject _eContainer_1 = _eContainer.eContainer();
      if ((_eContainer_1 instanceof ApplicationSession)) {
        _builder.append("getContext().");
        String _name = it.getName();
        String _firstUpper = StringExtensions.toFirstUpper(_name);
        _builder.append(_firstUpper, "");
        _builder.append("()");
      } else {
        String _name_1 = it.getName();
        String _firstUpper_1 = StringExtensions.toFirstUpper(_name_1);
        _builder.append(_firstUpper_1, "");
        _builder.append("(");
        EObject _eContainer_2 = it.eContainer();
        EObject _eContainer_3 = _eContainer_2.eContainer();
        String _variableName = this._names.toVariableName(_eContainer_3);
        _builder.append(_variableName, "");
        _builder.append(")");
      }
    }
    String _endAtomicExpr = this.endAtomicExpr(it, variable);
    _builder.append(_endAtomicExpr, "");
    return _builder.toString();
  }
  
  protected String _compile(final Call it) {
    StringConcatenation _builder = new StringConcatenation();
    String _beginAtomicExpr = this.beginAtomicExpr(it, it);
    _builder.append(_beginAtomicExpr, "");
    _builder.append("getContext().");
    Function _function = it.getFunction();
    String _name = _function.getName();
    _builder.append(_name, "");
    _builder.append("(");
    Literal _expr = it.getExpr();
    String _compile = this.compile(_expr);
    _builder.append(_compile, "");
    _builder.append(")");
    String _endAtomicExpr = this.endAtomicExpr(it, it);
    _builder.append(_endAtomicExpr, "");
    return _builder.toString();
  }
  
  protected String _compile(final ParenExpr it) {
    String _xblockexpression = null;
    {
      StringConcatenation _builder = new StringConcatenation();
      String _beginAtomicExpr = this.beginAtomicExpr(it, it);
      _builder.append(_beginAtomicExpr, "");
      _builder.append("(");
      EqualityExpr _expr = it.getExpr();
      String _compile = this.compile(_expr);
      _builder.append(_compile, "");
      _builder.append(")");
      String _endAtomicExpr = this.endAtomicExpr(it, it);
      _builder.append(_endAtomicExpr, "");
      final String result = _builder.toString();
      EObject _rootContainer = EcoreUtil.getRootContainer(it);
      Object _property = EObjectPropertiesAdapter.getProperty(_rootContainer, "parenExpr");
      boolean _notEquals = (!Objects.equal(_property, null));
      if (_notEquals) {
        EObject _rootContainer_1 = EcoreUtil.getRootContainer(it);
        EObjectPropertiesAdapter.removeProperty(_rootContainer_1, "parenExpr");
      }
      String _string = result.toString();
      _xblockexpression = (_string);
    }
    return _xblockexpression;
  }
  
  protected String _compile(final Literal it) {
    StringConcatenation _builder = new StringConcatenation();
    return _builder.toString();
  }
  
  protected String _compile(final IntLiteral it) {
    StringConcatenation _builder = new StringConcatenation();
    String _beginAtomicExpr = this.beginAtomicExpr(it, it);
    _builder.append(_beginAtomicExpr, "");
    int _number = it.getNumber();
    _builder.append(_number, "");
    String _endAtomicExpr = this.endAtomicExpr(it, it);
    _builder.append(_endAtomicExpr, "");
    return _builder.toString();
  }
  
  protected String _compile(final StringLiteral it) {
    StringConcatenation _builder = new StringConcatenation();
    String _beginAtomicExpr = this.beginAtomicExpr(it, it);
    _builder.append(_beginAtomicExpr, "");
    _builder.append("\"");
    String _string = it.getString();
    _builder.append(_string, "");
    _builder.append("\"");
    String _endAtomicExpr = this.endAtomicExpr(it, it);
    _builder.append(_endAtomicExpr, "");
    return _builder.toString();
  }
  
  protected String _compile(final TrueLiteral it) {
    StringConcatenation _builder = new StringConcatenation();
    String _beginAtomicExpr = this.beginAtomicExpr(it, it);
    _builder.append(_beginAtomicExpr, "");
    _builder.append("Boolean.TRUE");
    String _endAtomicExpr = this.endAtomicExpr(it, it);
    _builder.append(_endAtomicExpr, "");
    return _builder.toString();
  }
  
  protected String _compile(final FalseLiteral it) {
    StringConcatenation _builder = new StringConcatenation();
    String _beginAtomicExpr = this.beginAtomicExpr(it, it);
    _builder.append(_beginAtomicExpr, "");
    _builder.append("Boolean.FALSE");
    String _endAtomicExpr = this.endAtomicExpr(it, it);
    _builder.append(_endAtomicExpr, "");
    return _builder.toString();
  }
  
  protected String _compile(final Attribute it, final Variable variable) {
    String _xifexpression = null;
    boolean _and = false;
    Type _dataType = it.getDataType();
    if (!(_dataType instanceof SimpleType)) {
      _and = false;
    } else {
      Type _dataType_1 = it.getDataType();
      Boolean _isPrimitiveWrapperType = SimpleTypeExtension.isPrimitiveWrapperType(((SimpleType) _dataType_1));
      _and = ((_dataType instanceof SimpleType) && (_isPrimitiveWrapperType).booleanValue());
    }
    if (_and) {
      StringConcatenation _builder = new StringConcatenation();
      String _beginAtomicExpr = this.beginAtomicExpr(it, variable);
      _builder.append(_beginAtomicExpr, "");
      _builder.append("getValue(");
      EObject _eContainer = it.eContainer();
      String _variableName = this._names.toVariableName(_eContainer);
      _builder.append(_variableName, "");
      _builder.append(",\"");
      String _name = it.getName();
      _builder.append(_name, "");
      _builder.append("\",");
      DataTypeAndTypeParameter _type = it.getType();
      String _qualifiedName = this._names.getQualifiedName(_type);
      _builder.append(_qualifiedName, "");
      _builder.append(".class)");
      String _endAtomicExpr = this.endAtomicExpr(it, variable);
      _builder.append(_endAtomicExpr, "");
      _xifexpression = _builder.toString();
    } else {
      StringConcatenation _builder_1 = new StringConcatenation();
      String _beginAtomicExpr_1 = this.beginAtomicExpr(it, variable);
      _builder_1.append(_beginAtomicExpr_1, "");
      EObject _eContainer_1 = it.eContainer();
      String _variableName_1 = this._names.toVariableName(_eContainer_1);
      _builder_1.append(_variableName_1, "");
      _builder_1.append(".");
      String _accessorMethodName = this._features.getAccessorMethodName(it);
      _builder_1.append(_accessorMethodName, "");
      _builder_1.append("()");
      String _endAtomicExpr_1 = this.endAtomicExpr(it, variable);
      _builder_1.append(_endAtomicExpr_1, "");
      _xifexpression = _builder_1.toString();
    }
    return _xifexpression;
  }
  
  protected String _beginAtomicExpr(final EObject it, final AtomicExpr atomicExpr) {
    String _popOperator = ExpressionExtension.popOperator(it);
    return _popOperator;
  }
  
  protected String _beginAtomicExpr(final Property it, final AtomicExpr atomicExpr) {
    String _xifexpression = null;
    SimpleType _type = it.getType();
    Boolean _isPrimitiveWrapperType = SimpleTypeExtension.isPrimitiveWrapperType(_type);
    boolean _not = (!(_isPrimitiveWrapperType).booleanValue());
    if (_not) {
      String _objectExpressionValue = this.objectExpressionValue(it, atomicExpr);
      _xifexpression = _objectExpressionValue;
    } else {
      String _popOperator = ExpressionExtension.popOperator(it);
      _xifexpression = _popOperator;
    }
    return _xifexpression;
  }
  
  protected String _beginAtomicExpr(final Attribute it, final AtomicExpr atomicExpr) {
    String _xifexpression = null;
    boolean _or = false;
    Type _dataType = it.getDataType();
    boolean _not = (!(_dataType instanceof SimpleType));
    if (_not) {
      _or = true;
    } else {
      Type _dataType_1 = it.getDataType();
      Boolean _isPrimitiveWrapperType = SimpleTypeExtension.isPrimitiveWrapperType(((SimpleType) _dataType_1));
      boolean _not_1 = (!(_isPrimitiveWrapperType).booleanValue());
      _or = (_not || _not_1);
    }
    if (_or) {
      String _objectExpressionValue = this.objectExpressionValue(it, atomicExpr);
      _xifexpression = _objectExpressionValue;
    } else {
      String _popOperator = ExpressionExtension.popOperator(it);
      _xifexpression = _popOperator;
    }
    return _xifexpression;
  }
  
  protected String _beginAtomicExpr(final StringLiteral it, final AtomicExpr atomicExpr) {
    String _xifexpression = null;
    EObject _eContainer = it.eContainer();
    boolean _not = (!(_eContainer instanceof Call));
    if (_not) {
      String _objectExpressionValue = this.objectExpressionValue(it, atomicExpr);
      _xifexpression = _objectExpressionValue;
    }
    return _xifexpression;
  }
  
  protected String _beginAtomicExpr(final ParenExpr it, final AtomicExpr atomicExpr) {
    String _xifexpression = null;
    EqualityExpr _expr = it.getExpr();
    boolean _isPrimitiveWrapperType = ExpressionExtension.isPrimitiveWrapperType(_expr);
    boolean _not = (!_isPrimitiveWrapperType);
    if (_not) {
      StringConcatenation _builder = new StringConcatenation();
      String _objectExpressionValue = this.objectExpressionValue(it, it);
      _builder.append(_objectExpressionValue, "");
      EObject _rootContainer = EcoreUtil.getRootContainer(atomicExpr);
      EObjectPropertiesAdapter.setProperty(_rootContainer, "parenExpr", "true");
      _xifexpression = _builder.toString();
    } else {
      String _popOperator = ExpressionExtension.popOperator(it);
      _xifexpression = _popOperator;
    }
    return _xifexpression;
  }
  
  protected String _beginAtomicExpr(final Call it, final AtomicExpr atomicExpr) {
    String _xifexpression = null;
    Function _function = it.getFunction();
    SimpleType _resultType = _function.getResultType();
    Boolean _isPrimitiveWrapperType = SimpleTypeExtension.isPrimitiveWrapperType(_resultType);
    boolean _not = (!(_isPrimitiveWrapperType).booleanValue());
    if (_not) {
      String _objectExpressionValue = this.objectExpressionValue(it, it);
      _xifexpression = _objectExpressionValue;
    } else {
      String _popOperator = ExpressionExtension.popOperator(it);
      _xifexpression = _popOperator;
    }
    return _xifexpression;
  }
  
  public String objectExpressionValue(final EObject it, final AtomicExpr atomicExpr) {
    String _xblockexpression = null;
    {
      String result = "";
      final String operator = ExpressionExtension.popOperator(it);
      boolean _or = false;
      boolean _equals = "==".equals(operator);
      if (_equals) {
        _or = true;
      } else {
        boolean _equals_1 = "!=".equals(operator);
        _or = (_equals || _equals_1);
      }
      if (_or) {
        result = ".equals(";
        EObject _rootContainer = EcoreUtil.getRootContainer(atomicExpr);
        EObjectPropertiesAdapter.setProperty(_rootContainer, "equals", "true");
      } else {
        result = operator;
      }
      String _nextOperator = ExpressionExtension.getNextOperator(atomicExpr);
      boolean _equals_2 = "!=".equals(_nextOperator);
      if (_equals_2) {
        EObject _rootContainer_1 = EcoreUtil.getRootContainer(atomicExpr);
        Object _property = EObjectPropertiesAdapter.getProperty(_rootContainer_1, "parenExpr");
        boolean _equals_3 = Objects.equal(_property, null);
        if (_equals_3) {
          String _plus = (result + "!(");
          result = _plus;
          EObject _rootContainer_2 = EcoreUtil.getRootContainer(atomicExpr);
          EObjectPropertiesAdapter.setProperty(_rootContainer_2, "equals", "true");
        }
      }
      _xblockexpression = (result);
    }
    return _xblockexpression;
  }
  
  public String endAtomicExpr(final EObject it, final AtomicExpr atomicExpr) {
    EObject _rootContainer = EcoreUtil.getRootContainer(atomicExpr);
    boolean _hasProperty = EObjectPropertiesAdapter.hasProperty(_rootContainer, "equals");
    if (_hasProperty) {
      EObject _rootContainer_1 = EcoreUtil.getRootContainer(atomicExpr);
      EObjectPropertiesAdapter.removeProperty(_rootContainer_1, "equals");
      return ")";
    }
    return "";
  }
  
  public String compileLeftThenRight(final EObject left, final Iterable<? extends EObject> rights) {
    String _xblockexpression = null;
    {
      String _compile = this.compile(left);
      StringBuilder _stringBuilder = new StringBuilder(_compile);
      final StringBuilder result = _stringBuilder;
      final Procedure1<EObject> _function = new Procedure1<EObject>() {
          public void apply(final EObject e) {
            String _compile = ExpressionCompiler.this.compile(e);
            result.append(_compile);
          }
        };
      IterableExtensions.forEach(rights, _function);
      String _string = result.toString();
      _xblockexpression = (_string);
    }
    return _xblockexpression;
  }
  
  public String compile(final EObject it) {
    if (it instanceof FalseLiteral) {
      return _compile((FalseLiteral)it);
    } else if (it instanceof TrueLiteral) {
      return _compile((TrueLiteral)it);
    } else if (it instanceof IntLiteral) {
      return _compile((IntLiteral)it);
    } else if (it instanceof StringLiteral) {
      return _compile((StringLiteral)it);
    } else if (it instanceof XmadslVariable) {
      return _compile((XmadslVariable)it);
    } else if (it instanceof Call) {
      return _compile((Call)it);
    } else if (it instanceof Literal) {
      return _compile((Literal)it);
    } else if (it instanceof ParenExpr) {
      return _compile((ParenExpr)it);
    } else if (it instanceof RelationalExpr) {
      return _compile((RelationalExpr)it);
    } else if (it instanceof AdditiveExpr) {
      return _compile((AdditiveExpr)it);
    } else if (it instanceof AdditiveRights) {
      return _compile((AdditiveRights)it);
    } else if (it instanceof CondANDExpr) {
      return _compile((CondANDExpr)it);
    } else if (it instanceof CondANDRights) {
      return _compile((CondANDRights)it);
    } else if (it instanceof CondORExpr) {
      return _compile((CondORExpr)it);
    } else if (it instanceof CondORRights) {
      return _compile((CondORRights)it);
    } else if (it instanceof EqualityExpr) {
      return _compile((EqualityExpr)it);
    } else if (it instanceof MultiplicativeExpr) {
      return _compile((MultiplicativeExpr)it);
    } else if (it instanceof MultiplicativeRights) {
      return _compile((MultiplicativeRights)it);
    } else if (it != null) {
      return _compile(it);
    } else {
      throw new IllegalArgumentException("Unhandled parameter types: " +
        Arrays.<Object>asList(it).toString());
    }
  }
  
  public String compile(final ReferenceableByXmadslVariable it, final Variable variable) {
    if (it instanceof StatusFlag) {
      return _compile((StatusFlag)it, variable);
    } else if (it instanceof Attribute) {
      return _compile((Attribute)it, variable);
    } else if (it instanceof Property) {
      return _compile((Property)it, variable);
    } else {
      throw new IllegalArgumentException("Unhandled parameter types: " +
        Arrays.<Object>asList(it, variable).toString());
    }
  }
  
  public String beginAtomicExpr(final EObject it, final AtomicExpr atomicExpr) {
    if (it instanceof StringLiteral) {
      return _beginAtomicExpr((StringLiteral)it, atomicExpr);
    } else if (it instanceof Call) {
      return _beginAtomicExpr((Call)it, atomicExpr);
    } else if (it instanceof ParenExpr) {
      return _beginAtomicExpr((ParenExpr)it, atomicExpr);
    } else if (it instanceof Attribute) {
      return _beginAtomicExpr((Attribute)it, atomicExpr);
    } else if (it instanceof Property) {
      return _beginAtomicExpr((Property)it, atomicExpr);
    } else if (it != null) {
      return _beginAtomicExpr(it, atomicExpr);
    } else {
      throw new IllegalArgumentException("Unhandled parameter types: " +
        Arrays.<Object>asList(it, atomicExpr).toString());
    }
  }
}
