package org.openxma.dsl.generator.impl;

import java.io.File;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.eclipse.core.resources.IFolder;
import org.eclipse.core.resources.IWorkspace;
import org.eclipse.core.resources.IWorkspaceRoot;
import org.eclipse.core.resources.ResourcesPlugin;
import org.eclipse.core.runtime.Path;
import org.eclipse.emf.common.notify.Notifier;
import org.eclipse.emf.common.util.URI;
import org.eclipse.xtext.generator.IFileSystemAccess;
import org.eclipse.xtext.generator.IFileSystemAccessExtension2;
import org.eclipse.xtext.xbase.lib.Functions.Function0;
import org.openxma.dsl.generator.component.HbmFileMergePostProcessor;
import org.openxma.dsl.generator.impl.XtendDomGenerator;
import org.openxma.dsl.generator.lib.ImportAdapter;

@SuppressWarnings("all")
public class IFileSystemAccessDelegate implements IFileSystemAccess {
  private final Log logger = new Function0<Log>() {
    public Log apply() {
      String _name = XtendDomGenerator.class.getName();
      Log _log = LogFactory.getLog(_name);
      return _log;
    }
  }.apply();
  
  private final IFileSystemAccess delegate;
  
  private final Notifier notifier;
  
  private final HbmFileMergePostProcessor hbmFileMergePostProcessor = new Function0<HbmFileMergePostProcessor>() {
    public HbmFileMergePostProcessor apply() {
      HbmFileMergePostProcessor _hbmFileMergePostProcessor = new HbmFileMergePostProcessor();
      return _hbmFileMergePostProcessor;
    }
  }.apply();
  
  public IFileSystemAccessDelegate(final IFileSystemAccess delegate, final Notifier notifier) {
    this.delegate = delegate;
    this.notifier = notifier;
  }
  
  public void deleteFile(final String fileName) {
    this.delegate.deleteFile(fileName);
  }
  
  public void generateFile(final String fileName, final CharSequence contents) {
    this.generateFile(fileName, IFileSystemAccess.DEFAULT_OUTPUT, contents);
  }
  
  public void generateFile(final String fileName, final String outputConfigurationName, final CharSequence contents) {
    String _plus = ("Write " + fileName);
    this.logger.info(_plus);
    String _string = contents.toString();
    String _resolve = ImportAdapter.resolve(this.notifier, _string);
    this.delegate.generateFile(fileName, outputConfigurationName, _resolve);
    final URI uri = ((IFileSystemAccessExtension2) this.delegate).getURI(fileName, outputConfigurationName);
    boolean _isPlatform = uri.isPlatform();
    if (_isPlatform) {
      IWorkspace _workspace = ResourcesPlugin.getWorkspace();
      final IWorkspaceRoot root = _workspace.getRoot();
      String _platformString = uri.toPlatformString(true);
      Path _path = new Path(_platformString);
      final IFolder folder = root.getFolder(_path);
      java.net.URI _locationURI = folder.getLocationURI();
      File _file = new File(_locationURI);
      this.hbmFileMergePostProcessor.afterClose(_file);
    } else {
      boolean _isFile = uri.isFile();
      if (_isFile) {
        String _fileString = uri.toFileString();
        File _file_1 = new File(_fileString);
        this.hbmFileMergePostProcessor.afterClose(_file_1);
      }
    }
  }
}
