package org.openxma.dsl.generator.impl;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.eclipse.emf.common.notify.Notifier;
import org.eclipse.xtext.generator.IFileSystemAccess;
import org.eclipse.xtext.xbase.lib.Functions.Function0;
import org.openxma.dsl.generator.impl.XtendDomGenerator;
import org.openxma.dsl.generator.lib.ImportAdapter;

@SuppressWarnings("all")
public class IGeneratorDelegate implements IFileSystemAccess {
  private final Log logger = new Function0<Log>() {
    public Log apply() {
      String _name = XtendDomGenerator.class.getName();
      Log _log = LogFactory.getLog(_name);
      return _log;
    }
  }.apply();
  
  private final IFileSystemAccess delegate;
  
  private final Notifier notifier;
  
  public IGeneratorDelegate(final IFileSystemAccess delegate, final Notifier notifier) {
    this.delegate = delegate;
    this.notifier = notifier;
  }
  
  public void deleteFile(final String fileName) {
    this.delegate.deleteFile(fileName);
  }
  
  public void generateFile(final String fileName, final CharSequence contents) {
    this.generateFile(fileName, IFileSystemAccess.DEFAULT_OUTPUT, contents);
  }
  
  public void generateFile(final String fileName, final String outputConfigurationName, final CharSequence contents) {
    String _plus = ("Write " + fileName);
    this.logger.info(_plus);
    String _string = contents.toString();
    String _resolve = ImportAdapter.resolve(this.notifier, _string);
    this.delegate.generateFile(fileName, outputConfigurationName, _resolve);
  }
}
