package org.openxma.dsl.generator.impl;

import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EObject;
import org.openxma.dsl.pom.model.CustomizeableField;
import org.openxma.dsl.pom.model.DataObjectVariable;
import org.openxma.dsl.pom.model.ObjectProperty;
import org.openxma.dsl.pom.model.Table;
import org.openxma.dsl.pom.model.TableCombo;
import org.openxma.dsl.pom.model.Tree;

import com.google.inject.ImplementedBy;

@ImplementedBy(JsfDataImpl.class)
public interface JsfData {

    CharSequence toDataObjectVars(EList<DataObjectVariable> variables);

    CharSequence toObjectPropertyVars(EList<ObjectProperty> properties);

    CharSequence toInjectedDependencies(EList dependencies);

    CharSequence toGetterAndSetter(EObject dataObject);

    CharSequence getModelPropertyName(Table table);
    
    CharSequence getRootNodePropertyName(Tree tree);

    CharSequence getSelectedNodePropertyName(Tree tree);

    CharSequence getModelPropertyNameFirstUpper(Table table);
    
    CharSequence getRootNodePropertyNameFirstUpper(Tree tree);

    CharSequence getSelectedNodePropertyNameFirstUpper(Tree tree);

    CharSequence getSelectItemsPropertyName(CustomizeableField field);

    CharSequence getSelectItemsPropertyNameFirstUpper(CustomizeableField field);

    CharSequence toJsfDataModel(EObject composite);

}