package org.openxma.dsl.generator.impl;

import at.spardat.xma.guidesign.XMAComponent;
import com.google.inject.Singleton;
import java.beans.Introspector;
import java.util.Arrays;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.xtext.xbase.lib.IterableExtensions;
import org.eclipse.xtext.xbase.lib.StringExtensions;
import org.openxma.dsl.generator.impl.JsfNames;
import org.openxma.dsl.pom.model.Command;
import org.openxma.dsl.pom.model.Component;
import org.openxma.dsl.pom.model.ObjectProperty;
import org.openxma.dsl.pom.model.Page;
import org.openxma.dsl.pom.model.Table;
import org.openxma.dsl.pom.model.TableColumn;
import org.openxma.dsl.pom.model.XmadslPage;

@Singleton
@SuppressWarnings("all")
public class JsfNamesImpl implements JsfNames {
  protected CharSequence _getJSClass(final Component component) {
    XMAComponent _xmaComponent = component.getXmaComponent();
    String _namClass = _xmaComponent.getNamClass();
    return _namClass;
  }
  
  protected CharSequence _getJSClass(final XmadslPage page) {
    String _name = page.getName();
    return _name;
  }
  
  public CharSequence asIdentifier(final String s) {
    double _random = Math.random();
    String _string = Double.valueOf(_random).toString();
    String _substring = _string.substring(2);
    String _plus = (s + _substring);
    return _plus;
  }
  
  public CharSequence getBean(final XmadslPage page) {
    String _name = page.getName();
    String _firstLower = StringExtensions.toFirstLower(_name);
    return _firstLower;
  }
  
  public CharSequence getDialogWidgetVar(final XmadslPage page) {
    String _name = page.getName();
    String _firstLower = StringExtensions.toFirstLower(_name);
    String _plus = (_firstLower + "Var");
    return _plus;
  }
  
  protected CharSequence _getWidgetVar(final EObject page) {
    RuntimeException _runtimeException = new RuntimeException("No widget var for this element type!");
    throw _runtimeException;
  }
  
  protected CharSequence _getWidgetVar(final Table table) {
    XmadslPage _parentPage = this.getParentPage(table);
    CharSequence _jSClass = this.getJSClass(_parentPage);
    String _plus = (_jSClass + "_");
    String _name = table.getName();
    String _plus_1 = (_plus + _name);
    String _plus_2 = (_plus_1 + "WidgetVar");
    return _plus_2;
  }
  
  protected CharSequence _getWidgetVar(final Component component) {
    XMAComponent _xmaComponent = component.getXmaComponent();
    String _namClass = _xmaComponent.getNamClass();
    String _firstLower = StringExtensions.toFirstLower(_namClass);
    return _firstLower;
  }
  
  protected CharSequence _getWidgetVar(final XmadslPage page) {
    String _name = page.getName();
    String _firstLower = StringExtensions.toFirstLower(_name);
    return _firstLower;
  }
  
  protected CharSequence _getWidgetVar(final ObjectProperty property) {
    XmadslPage _parentPage = this.getParentPage(property);
    CharSequence _jSClass = this.getJSClass(_parentPage);
    String _plus = (_jSClass + "_");
    String _name = property.getName();
    String _plus_1 = (_plus + _name);
    String _plus_2 = (_plus_1 + "Prop");
    return _plus_2;
  }
  
  protected CharSequence _getWidgetVar(final Command command) {
    String _xifexpression = null;
    EObject _eContainer = command.eContainer();
    if ((_eContainer instanceof Component)) {
      EObject _eContainer_1 = command.eContainer();
      CharSequence _jSClass = this.getJSClass(((Component) _eContainer_1));
      String _plus = (_jSClass + "_");
      String _name = command.getName();
      String _plus_1 = (_plus + _name);
      String _plus_2 = (_plus_1 + "Cmd");
      _xifexpression = _plus_2;
    } else {
      XmadslPage _parentPage = this.getParentPage(command);
      CharSequence _jSClass_1 = this.getJSClass(_parentPage);
      String _plus_3 = (_jSClass_1 + "_");
      String _name_1 = command.getName();
      String _plus_4 = (_plus_3 + _name_1);
      String _plus_5 = (_plus_4 + "Cmd");
      _xifexpression = _plus_5;
    }
    return _xifexpression;
  }
  
  protected CharSequence _referencedBean(final Component component) {
    XMAComponent _xmaComponent = component.getXmaComponent();
    String _namClass = _xmaComponent.getNamClass();
    String _firstLower = StringExtensions.toFirstLower(_namClass);
    return _firstLower;
  }
  
  protected CharSequence _referencedBean(final XmadslPage page) {
    String _name = page.getName();
    String _firstLower = StringExtensions.toFirstLower(_name);
    return _firstLower;
  }
  
  public Component component(final XmadslPage page) {
    EObject _eContainer = page.eContainer();
    return ((Component) _eContainer);
  }
  
  public XmadslPage mainPage(final Component component) {
    EList<Page> _pages = component.getPages();
    Page _head = _pages==null?(Page)null:IterableExtensions.<Page>head(_pages);
    return ((XmadslPage) _head);
  }
  
  public XmadslPage getParentPage(final TableColumn tableColumn) {
    XmadslPage _xblockexpression = null;
    {
      EObject parent = tableColumn.eContainer();
      boolean _dowhile = false;
      do {
        EObject _eContainer = parent.eContainer();
        parent = _eContainer;
        boolean _not = (!(parent instanceof XmadslPage));
        _dowhile = _not;
      } while(_dowhile);
      _xblockexpression = (((XmadslPage) parent));
    }
    return _xblockexpression;
  }
  
  public XmadslPage getParentPage(final EObject container) {
    XmadslPage _xblockexpression = null;
    {
      EObject parent = container;
      boolean _not = (!(parent instanceof XmadslPage));
      boolean _while = _not;
      while (_while) {
        EObject _eContainer = parent.eContainer();
        parent = _eContainer;
        boolean _not_1 = (!(parent instanceof XmadslPage));
        _while = _not_1;
      }
      _xblockexpression = (((XmadslPage) parent));
    }
    return _xblockexpression;
  }
  
  /**
   * Takes care of JSF specific capitalization
   * @see http://www.rqna.net/qna/uwzkp-jsf-2-managed-beans-property-not-found.html
   * @see http://www.oracle.com/technetwork/java/javase/documentation/spec-136004.html
   */
  public String getFaceletName(final String n) {
    String _firstUpper = StringExtensions.toFirstUpper(n);
    String _decapitalize = Introspector.decapitalize(_firstUpper);
    return _decapitalize;
  }
  
  public CharSequence getJSClass(final EObject page) {
    if (page instanceof XmadslPage) {
      return _getJSClass((XmadslPage)page);
    } else if (page instanceof Component) {
      return _getJSClass((Component)page);
    } else {
      throw new IllegalArgumentException("Unhandled parameter types: " +
        Arrays.<Object>asList(page).toString());
    }
  }
  
  public CharSequence getWidgetVar(final EObject table) {
    if (table instanceof Table) {
      return _getWidgetVar((Table)table);
    } else if (table instanceof XmadslPage) {
      return _getWidgetVar((XmadslPage)table);
    } else if (table instanceof Component) {
      return _getWidgetVar((Component)table);
    } else if (table instanceof Command) {
      return _getWidgetVar((Command)table);
    } else if (table instanceof ObjectProperty) {
      return _getWidgetVar((ObjectProperty)table);
    } else if (table != null) {
      return _getWidgetVar(table);
    } else {
      throw new IllegalArgumentException("Unhandled parameter types: " +
        Arrays.<Object>asList(table).toString());
    }
  }
  
  public CharSequence referencedBean(final EObject page) {
    if (page instanceof XmadslPage) {
      return _referencedBean((XmadslPage)page);
    } else if (page instanceof Component) {
      return _referencedBean((Component)page);
    } else {
      throw new IllegalArgumentException("Unhandled parameter types: " +
        Arrays.<Object>asList(page).toString());
    }
  }
}
