package org.openxma.dsl.generator.impl;

import com.google.common.base.Objects;
import java.util.Arrays;
import org.eclipse.emf.ecore.EObject;
import org.openxma.dsl.core.model.Model;
import org.openxma.dsl.core.model.Type;
import org.openxma.dsl.dom.model.Attribute;
import org.openxma.dsl.dom.model.DataView;
import org.openxma.dsl.dom.model.Entity;
import org.openxma.dsl.dom.model.PresentableFeature;
import org.openxma.dsl.dom.model.ValueObject;
import org.openxma.dsl.generator.impl.Types;

@SuppressWarnings("all")
public class TypesImpl implements Types {
  protected Type _parentType(final Attribute att) {
    Type _switchResult = null;
    EObject _eContainer = att.eContainer();
    final EObject _switchValue = _eContainer;
    boolean _matched = false;
    if (!_matched) {
      if (_switchValue instanceof ValueObject) {
        final ValueObject _valueObject = (ValueObject)_switchValue;
        _matched=true;
        EObject _eContainer_1 = att.eContainer();
        _switchResult = ((ValueObject) _eContainer_1);
      }
    }
    if (!_matched) {
      if (_switchValue instanceof DataView) {
        final DataView _dataView = (DataView)_switchValue;
        _matched=true;
        EObject _eContainer_1 = att.eContainer();
        _switchResult = ((DataView) _eContainer_1);
      }
    }
    if (!_matched) {
      if (_switchValue instanceof Entity) {
        final Entity _entity = (Entity)_switchValue;
        _matched=true;
        EObject _eContainer_1 = att.eContainer();
        Type _pomType = this.pomType(((Entity) _eContainer_1));
        _switchResult = _pomType;
      }
    }
    if (!_matched) {
      _switchResult = null;
    }
    return _switchResult;
  }
  
  protected Type _parentType(final PresentableFeature feature) {
    Type _switchResult = null;
    EObject _eContainer = feature.eContainer();
    final EObject _switchValue = _eContainer;
    boolean _matched = false;
    if (!_matched) {
      if (_switchValue instanceof ValueObject) {
        final ValueObject _valueObject = (ValueObject)_switchValue;
        _matched=true;
        EObject _eContainer_1 = feature.eContainer();
        _switchResult = ((ValueObject) _eContainer_1);
      }
    }
    if (!_matched) {
      if (_switchValue instanceof DataView) {
        final DataView _dataView = (DataView)_switchValue;
        _matched=true;
        EObject _eContainer_1 = feature.eContainer();
        _switchResult = ((DataView) _eContainer_1);
      }
    }
    if (!_matched) {
      if (_switchValue instanceof Entity) {
        final Entity _entity = (Entity)_switchValue;
        _matched=true;
        EObject _eContainer_1 = feature.eContainer();
        Type _pomType = this.pomType(((Entity) _eContainer_1));
        _switchResult = _pomType;
      }
    }
    if (!_matched) {
      _switchResult = null;
    }
    return _switchResult;
  }
  
  public Type pomType(final Type type) {
    Type _switchResult = null;
    boolean _matched = false;
    if (!_matched) {
      if (type instanceof Entity) {
        final Entity _entity = (Entity)type;
        _matched=true;
        DataView _defaultDataView = _entity.getDefaultDataView();
        _switchResult = _defaultDataView;
      }
    }
    if (!_matched) {
      _switchResult = type;
    }
    return _switchResult;
  }
  
  public Model model(final EObject eObject) {
    Model _xblockexpression = null;
    {
      EObject result = eObject;
      boolean _and = false;
      boolean _not = (!(result instanceof Model));
      if (!_not) {
        _and = false;
      } else {
        EObject _eContainer = result.eContainer();
        boolean _notEquals = (!Objects.equal(_eContainer, null));
        _and = (_not && _notEquals);
      }
      boolean _while = _and;
      while (_while) {
        EObject _eContainer_1 = result.eContainer();
        result = _eContainer_1;
        boolean _and_1 = false;
        boolean _not_1 = (!(result instanceof Model));
        if (!_not_1) {
          _and_1 = false;
        } else {
          EObject _eContainer_2 = result.eContainer();
          boolean _notEquals_1 = (!Objects.equal(_eContainer_2, null));
          _and_1 = (_not_1 && _notEquals_1);
        }
        _while = _and_1;
      }
      _xblockexpression = (((Model) result));
    }
    return _xblockexpression;
  }
  
  public Type parentType(final PresentableFeature att) {
    if (att instanceof Attribute) {
      return _parentType((Attribute)att);
    } else if (att != null) {
      return _parentType(att);
    } else {
      throw new IllegalArgumentException("Unhandled parameter types: " +
        Arrays.<Object>asList(att).toString());
    }
  }
}
