package org.openxma.dsl.generator.lib;

import com.google.common.base.Objects;
import com.google.common.collect.Sets;
import java.util.Iterator;
import java.util.Set;
import java.util.TreeSet;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notifier;
import org.eclipse.emf.common.notify.impl.AdapterImpl;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.emf.ecore.resource.ResourceSet;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.xtext.util.Strings;
import org.eclipse.xtext.xbase.lib.Functions.Function0;
import org.openxma.dsl.generator.Config;

@SuppressWarnings("all")
public class ImportAdapter extends AdapterImpl {
  private final Log logger = new Function0<Log>() {
    public Log apply() {
      Class<? extends ImportAdapter> _class = ImportAdapter.this.getClass();
      String _name = _class.getName();
      Log _log = LogFactory.getLog(_name);
      return _log;
    }
  }.apply();
  
  private String lastInsertMarker = null;
  
  private final Set<String> imports = new Function0<Set<String>>() {
    public Set<String> apply() {
      TreeSet<String> _newTreeSet = Sets.<String>newTreeSet();
      return _newTreeSet;
    }
  }.apply();
  
  public static String addImportsHere(final EObject eObject) {
    String _xblockexpression = null;
    {
      final ImportAdapter adapter = ImportAdapter.get(eObject);
      boolean _notEquals = (!Objects.equal(adapter.lastInsertMarker, null));
      if (_notEquals) {
        adapter.logger.warn("Multiple import sections");
      }
      adapter.imports.clear();
      long _currentTimeMillis = System.currentTimeMillis();
      String _plus = ("_Placeholder_for_a_lazy_import_section_" + Long.valueOf(_currentTimeMillis));
      String _plus_1 = (_plus + "___");
      adapter.lastInsertMarker = _plus_1;
      _xblockexpression = (adapter.lastInsertMarker);
    }
    return _xblockexpression;
  }
  
  public static String addImport(final EObject eObject, final String qualifiedName) {
    String _xblockexpression = null;
    {
      boolean _startsWith = qualifiedName.startsWith("java.lang");
      boolean _not = (!_startsWith);
      if (_not) {
        ImportAdapter _get = ImportAdapter.get(eObject);
        _get.imports.add(qualifiedName);
      }
      String _lastToken = Strings.lastToken(qualifiedName, ".");
      _xblockexpression = (_lastToken);
    }
    return _xblockexpression;
  }
  
  public static String resolve(final Notifier notifier, final String content) {
    String _xblockexpression = null;
    {
      String result = content;
      Adapter _existingAdapter = EcoreUtil.getExistingAdapter(notifier, ImportAdapter.class);
      final ImportAdapter adapter = ((ImportAdapter) _existingAdapter);
      boolean _notEquals = (!Objects.equal(adapter.lastInsertMarker, null));
      if (_notEquals) {
        StringBuilder _stringBuilder = new StringBuilder();
        final StringBuilder importBuilder = _stringBuilder;
        final Iterator<String> iterator = adapter.imports.iterator();
        boolean _hasNext = iterator.hasNext();
        boolean _while = _hasNext;
        while (_while) {
          {
            final String name = iterator.next();
            int _indexOf = name.indexOf(".");
            int _minus = (-1);
            boolean _greaterThan = (_indexOf > _minus);
            if (_greaterThan) {
              StringBuilder _append = importBuilder.append("import ");
              StringBuilder _append_1 = _append.append(name);
              _append_1.append(";");
              boolean _hasNext_1 = iterator.hasNext();
              if (_hasNext_1) {
                importBuilder.append(Config.NL);
              }
            }
          }
          boolean _hasNext_1 = iterator.hasNext();
          _while = _hasNext_1;
        }
        int _length = importBuilder.length();
        boolean _equals = (_length == 0);
        if (_equals) {
          String _plus = (adapter.lastInsertMarker + Config.NL);
          String _replace = result.replace(_plus, "");
          result = _replace;
        } else {
          String _string = importBuilder.toString();
          String _replace_1 = result.replace(adapter.lastInsertMarker, _string);
          result = _replace_1;
        }
        adapter.lastInsertMarker = null;
      }
      _xblockexpression = (result);
    }
    return _xblockexpression;
  }
  
  public static ImportAdapter get(final EObject eObject) {
    ImportAdapter _xblockexpression = null;
    {
      Resource _eResource = eObject.eResource();
      final ResourceSet notifier = _eResource.getResourceSet();
      Adapter _existingAdapter = EcoreUtil.getExistingAdapter(notifier, ImportAdapter.class);
      ImportAdapter adapter = ((ImportAdapter) _existingAdapter);
      boolean _equals = Objects.equal(adapter, null);
      if (_equals) {
        ImportAdapter _importAdapter = new ImportAdapter();
        adapter = _importAdapter;
        EList<Adapter> _eAdapters = notifier.eAdapters();
        _eAdapters.add(adapter);
      }
      _xblockexpression = (adapter);
    }
    return _xblockexpression;
  }
  
  public boolean isAdapterForType(final Object type) {
    Class<? extends ImportAdapter> _class = this.getClass();
    return Objects.equal(type, _class);
  }
}
