package org.openxma.dsl.generator.lib;

import at.spardat.xma.guidesign.BcdValidator;
import at.spardat.xma.guidesign.Validator;
import com.google.common.base.Objects;
import java.util.List;
import org.eclipse.xtext.xbase.lib.StringExtensions;
import org.openxma.dsl.core.model.BooleanParameterValue;
import org.openxma.dsl.core.model.BooleanValue;
import org.openxma.dsl.core.model.DataTypeAndTypeParameter;
import org.openxma.dsl.core.model.IntegerParameterValue;
import org.openxma.dsl.core.model.ParameterValue;
import org.openxma.dsl.core.model.ReferenceWithParameter;
import org.openxma.dsl.core.model.StringParameterValue;
import org.openxma.dsl.core.model.ValidatorReference;
import org.openxma.dsl.generator.helper.ValidatorExtension;

@SuppressWarnings("all")
public class ValidatorExtensions extends ValidatorExtension {
  public static Integer getPrecision(final DataTypeAndTypeParameter it) {
    boolean _hasNumberValidator = ValidatorExtension.hasNumberValidator(it);
    if (_hasNumberValidator) {
      ValidatorReference _validatorReferenceDefinition = it.getValidatorReferenceDefinition();
      List<ReferenceWithParameter> _definitionStack = it.getDefinitionStack();
      Validator _createXMAValidator = ValidatorExtension.createXMAValidator(_validatorReferenceDefinition, _definitionStack);
      final BcdValidator xmaValidator = ((BcdValidator) _createXMAValidator);
      Integer _xifexpression = null;
      String _cntBeforeComma = xmaValidator.getCntBeforeComma();
      boolean _isNullOrEmpty = StringExtensions.isNullOrEmpty(_cntBeforeComma);
      boolean _not = (!_isNullOrEmpty);
      if (_not) {
        String _cntBeforeComma_1 = xmaValidator.getCntBeforeComma();
        Integer _valueOf = Integer.valueOf(_cntBeforeComma_1);
        _xifexpression = _valueOf;
      } else {
        _xifexpression = null;
      }
      final Integer cntBeforeComma = _xifexpression;
      Integer _xifexpression_1 = null;
      String _cntAfterComma = xmaValidator.getCntAfterComma();
      boolean _isNullOrEmpty_1 = StringExtensions.isNullOrEmpty(_cntAfterComma);
      boolean _not_1 = (!_isNullOrEmpty_1);
      if (_not_1) {
        String _cntAfterComma_1 = xmaValidator.getCntAfterComma();
        Integer _valueOf_1 = Integer.valueOf(_cntAfterComma_1);
        _xifexpression_1 = _valueOf_1;
      } else {
        _xifexpression_1 = null;
      }
      Integer cntAfterComma = _xifexpression_1;
      boolean _and = false;
      boolean _notEquals = (!Objects.equal(cntBeforeComma, null));
      if (!_notEquals) {
        _and = false;
      } else {
        boolean _notEquals_1 = (!Objects.equal(cntAfterComma, null));
        _and = (_notEquals && _notEquals_1);
      }
      if (_and) {
        return ((cntBeforeComma).intValue() + (cntAfterComma).intValue());
      } else {
        boolean _notEquals_2 = (!Objects.equal(cntBeforeComma, null));
        if (_notEquals_2) {
          return cntBeforeComma;
        }
      }
    }
    return null;
  }
  
  public static Integer getScale(final DataTypeAndTypeParameter it) {
    boolean _hasNumberValidator = ValidatorExtension.hasNumberValidator(it);
    if (_hasNumberValidator) {
      ValidatorReference _validatorReferenceDefinition = it.getValidatorReferenceDefinition();
      List<ReferenceWithParameter> _definitionStack = it.getDefinitionStack();
      Validator _createXMAValidator = ValidatorExtension.createXMAValidator(_validatorReferenceDefinition, _definitionStack);
      final BcdValidator xmaValidator = ((BcdValidator) _createXMAValidator);
      String _cntAfterComma = xmaValidator.getCntAfterComma();
      boolean _isNullOrEmpty = StringExtensions.isNullOrEmpty(_cntAfterComma);
      boolean _not = (!_isNullOrEmpty);
      if (_not) {
        String _cntAfterComma_1 = xmaValidator.getCntAfterComma();
        return Integer.valueOf(_cntAfterComma_1);
      }
    }
    return null;
  }
  
  public static String getValueAsString(final ParameterValue it) {
    String _switchResult = null;
    boolean _matched = false;
    if (!_matched) {
      if (it instanceof IntegerParameterValue) {
        final IntegerParameterValue _integerParameterValue = (IntegerParameterValue)it;
        _matched=true;
        int _intValue = _integerParameterValue.getIntValue();
        String _string = Integer.valueOf(_intValue).toString();
        _switchResult = _string;
      }
    }
    if (!_matched) {
      if (it instanceof StringParameterValue) {
        final StringParameterValue _stringParameterValue = (StringParameterValue)it;
        _matched=true;
        String _stringValue = _stringParameterValue.getStringValue();
        _switchResult = _stringValue;
      }
    }
    if (!_matched) {
      if (it instanceof BooleanParameterValue) {
        final BooleanParameterValue _booleanParameterValue = (BooleanParameterValue)it;
        _matched=true;
        BooleanValue _booleanValue = _booleanParameterValue.getBooleanValue();
        String _string = _booleanValue.toString();
        _switchResult = _string;
      }
    }
    if (!_matched) {
      _switchResult = null;
    }
    return _switchResult;
  }
}
