package org.openxma.dsl.generator.lib

import at.spardat.xma.guidesign.BcdValidator
import org.openxma.dsl.core.model.BooleanParameterValue
import org.openxma.dsl.core.model.DataTypeAndTypeParameter
import org.openxma.dsl.core.model.IntegerParameterValue
import org.openxma.dsl.core.model.ParameterValue
import org.openxma.dsl.core.model.StringParameterValue
import org.openxma.dsl.generator.helper.ValidatorExtension

import static extension org.openxma.dsl.generator.helper.ValidatorExtension.*

class ValidatorExtensions extends ValidatorExtension {

	def static getPrecision(DataTypeAndTypeParameter it) {
		if (it.hasNumberValidator) {
			val xmaValidator = validatorReferenceDefinition.createXMAValidator(definitionStack) as BcdValidator
			val cntBeforeComma = if (!xmaValidator.cntBeforeComma.nullOrEmpty)
					Integer::valueOf(xmaValidator.cntBeforeComma)
				else
					null
			var cntAfterComma = if(!xmaValidator.cntAfterComma.nullOrEmpty)
					Integer::valueOf(xmaValidator.cntAfterComma)
				else
					null
			if (cntBeforeComma !=null && cntAfterComma !=null) {
				return cntBeforeComma + cntAfterComma
			} else if (cntBeforeComma !=null) {
				return cntBeforeComma
			}
		}
		return null
	}

	def static getScale(DataTypeAndTypeParameter it) {
		if (it.hasNumberValidator) {
			val xmaValidator = validatorReferenceDefinition.createXMAValidator(definitionStack) as BcdValidator
			if (!xmaValidator.cntAfterComma.nullOrEmpty) {
				return Integer::valueOf(xmaValidator.cntAfterComma)
			}
		}
		return null
	}

	def static String getValueAsString(ParameterValue it) {
		switch it {
			IntegerParameterValue: it.intValue.toString
			StringParameterValue: it.stringValue
			BooleanParameterValue: it.booleanValue.toString
            default : null
		}
	}

}
